        /* use Duff's device for non-aligned stuff */
        char* pD = pDest;
        char const* pS = pSrc;

        /* Calculate how many number of iterations are left
           which are a multiple of four. This is after the
           first entrance to the switch-case which performs
           the byte copying which are not a multiple of 4..i.e
           the trailing bytes. RSH 2 = Divide by 4.
           Essentially we are loop-unrolling at a depth of
           4 here.. */
        unsigned int byteAllignedCount = ( n + 3u ) >> 2u;

/* surpress warning "no 'break' before case label" */
#pragma warning 553
        switch ( n % 4u )
        {
        case 0u:
            do
            {
                *pD++ = *pS++;
                case 3u: *pD++ = *pS++;
                case 2u: *pD++ = *pS++;
                case 1u: *pD++ = *pS++;
            }
            /* Pre-decrement byteAllignedCount.
               This while loop condition is always tested  */
            while ( 0u < --byteAllignedCount );
        }
#pragma warning restore