#ifndef OBSERVATION_H_
#define OBSERVATION_H_

#include <avr/io.h>

inline void InitObservation(void)
{
    DDRB = (1<<PB0); // configure PB0 as output pin
}

inline void StartObservation(void)
{
    PORTB |= (1<<PB0); // set pin high
}

inline void StopObservation(void)
{
    PORTB &= ~(1<<PB0); // set pin low
}

#endif /* OBSERVATION_H_ */