#include <math.h>
#include <limits.h>
#include "Observation.h"

volatile unsigned short result, iGETmax, iGETmin;
unsigned short GETmax = 0;
unsigned short GETmin = UINT_MAX;
unsigned long GETavg = 0;

int main(void)
{
    unsigned short i = 0;
    InitObservation();
    do {
        StartObservation();
        result = (unsigned short) sqrt(i);
        StopObservation();
        GETavg += GetGrossExecutionTime();
        if(GetGrossExecutionTime() > GETmax) {
            GETmax = GetGrossExecutionTime();
            iGETmax = i;
        }
        if(GetGrossExecutionTime() < GETmin) {
            GETmin = GetGrossExecutionTime();
            iGETmin = i;
        }
        i++;
    } while (i != 0);
    GETavg >>= 16;
    return 0;
}