#if defined __GNUC__
#   include <machine/intrinsics.h>
#endif

inline unsigned char GetLinearCoreId(void)
{
#if defined __TASKING__
    unsigned char id = __mfcr(0xFE1C);
#elif defined __GNUC__
    unsigned char id = __MFCR(0xFE1C);
#else
#   error "compiler not supported"
#endif
    if (id > 5) {
        return 5;
    } else {
        return id;
    }
}

int main(void){
    return (int)GetLinearCoreId();
}